/* hmactestfc.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ok_hmac.h"

int test_hmac(){
    unsigned char ret[20],inp[256];
    unsigned char md5_ans[3][16]={
	{0x92,0x94,0x72,0x7a,0x36,0x38,0xbb,0x1c,
	 0x13,0xf4,0x8e,0xf8,0x15,0x8b,0xfc,0x9d},
	{0x75,0x0c,0x78,0x3e,0x6a,0xb0,0xb5,0x03,
	 0xea,0xa8,0x6e,0x31,0x0a,0x5d,0xb7,0x38},
	{0x56,0xbe,0x34,0x52,0x1d,0x14,0x4c,0x88,
	 0xdb,0xb8,0xc7,0x33,0xf0,0xe8,0xb3,0xf6}};

    unsigned char key[3][16]={
	{0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,
	 0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b,0x0b},
	{"Jefe"},
	{0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,
	 0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa}};
    char in[2][28]={
	{"Hi There"},
	{"what do ya want for nothing?"}};
    int	i;

    for(i=0;i<11;i++){
	HMAC_MD5(8,in[0],16,key[0],ret);
	if(memcmp(ret,md5_ans[0],16)){
	    printf("test HMAC_MD5 (1) -- error!\n");
	    return -1;
	}

	HMAC_MD5(28,in[1],4,key[1],ret);
	if(memcmp(ret,md5_ans[1],16)){
	    printf("test HMAC_MD5 (2) -- error!\n");
	    return -1;
	}

	memset(inp,0xdd,64);
	HMAC_MD5(50,inp,16,key[2],ret);
	if(memcmp(ret,md5_ans[2],16)){
	    printf("test HMAC_MD5 (3) -- error!\n");
	    return -1;
        }
	if((i%5)==0)printf("test HMAC_MD5 -- ok : %d\n",i);
    }

    return 0;
}
