/* uctest.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ok_uconv.h"

int make_table();

int main(int argc,char** argv){

	/* make_table(); */

	if(test_jis()){
		printf("error in test_jis..\n");
		exit(1);
	}
	if(test_sjis()){
		printf("error in test_sjis..\n");
		exit(1);
	}
	if(test_euc()){
		printf("error in test_euc..\n");
		exit(1);
	}
	return 0;
}


int make_table(){
	FILE *inf=NULL,*outf=NULL;
	char buf[1024];
	int i,j,k,l,u,br,err=-1;

	if((inf=fopen("JIS0208.csv","r"))==NULL){
		fprintf(stderr,"fopen error! -- inf\n");
		goto done;
	}
	if((outf=fopen("out.txt","w"))==NULL){
		fprintf(stderr,"fopen error! -- outf\n");
		goto done;
	}
	fprintf(outf,"unsigned short kuten[]={\n");

	i=j=0;
	while(fgets(buf,1024,inf)){
		sscanf(buf,"%x,%x,%x",&k,&l,&u);

		br=1;
		do{
			if(k==(i*0x100+j+0x2121)){
				fprintf(outf,"0x%.4x,",u); br=0;
			}else{
				fprintf(outf,"    -1,");
			}
			if((j%8)==7) fputs("\n\t",outf);
	
			printf("%x : %x,%x\n",i*0x100+j+0x2121,k,u);
			j++;
			if(j>=96){
				i++; j=0;
			}
		}while(br);
	}

	err=0;
done:
	if(inf) fclose(inf);
	if(outf) fclose(outf);
	return err;
}

