#!/bin/sh

echo "make new Certification Authority."

while test $# != 0
  do
  case $1 in
  -p12)
	shift
 	P12="-cap12 ca.p12"
	P12F=$1
	echo "use pkcs#12 file" $1 " as CA certificate."
	;;
  -keysize)
	shift
	KS="-ksize $1"
	;;
  -days)
	shift
	DAYS="-days $1"
	;;
  *)
	CANAME=$1
	;;
  esac
  shift
done

if test -d "$CANAME"; then
  echo "Directory $CANAME exists "
  exit 0
fi

if test $CANAME = ""; then
  echo "Cannot find CA name !!"
  exit 0
fi

mkdir $CANAME
mkdir $CANAME/cert

if test -n "$P12F"; then
  if test -f "$P12F"; then
    cp $P12F $CANAME/ca.p12
  fi
fi

cd $CANAME
aica new $P12 $KS $DAYS

if test -f "ca.cai"; then
  chmod go-rwx .
  chmod go-rwx ca.p12
  chmod go-rwx ca.cai

  aistore -i ca.cer

  echo "Succeeded to make new CA !!"
  if test -n "$P12F"; then
    echo "clean your $P12F before using new CA. It is more secure for new CA :-)"
  fi
else
  cd ..;rm -rf $CANAME
  echo "can not make new CA!!"
fi



