/* ok_caerr.h */
/*
 * Copyright (C) 1998-2001
 * Akira Iwata & Takuto Okuno
 * Akira Iwata Laboratory,
 * Nagoya Institute of Technology in Japan.
 *
 * All rights reserved.
 *
 * This software is written by Takuto Okuno(usapato@anet.ne.jp)
 * And if you want to contact us, send an email to Kimitake Wakayama
 * (wakayama@elcom.nitech.ac.jp)
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * 3. All advertising materials mentioning features or use of this software must
 *    display the following acknowledgment:
 *    "This product includes software developed by Akira Iwata Laboratory,
 *    Nagoya Institute of Technology in Japan (http://mars.elcom.nitech.ac.jp/)."
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Akira Iwata Laboratory,
 *     Nagoya Institute of Technology in Japan (http://mars.elcom.nitech.ac.jp/)."
 *
 *   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
 *   AKIRA IWATA LABORATORY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 *   SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 *   IN NO EVENT SHALL AKIRA IWATA LABORATORY BE LIABLE FOR ANY SPECIAL,
 *   INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 *   FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 *   NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION
 *   WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef __OK_CAERR_H__
#define __OK_CAERR_H__

#include "ok_err.h"

#ifdef  __cplusplus
extern "C" {
#endif

/*-----------------------------------------------
 * Define error location
 *---------------------------------------------*/
#define	ERR_LC_CA		0x80
#define	ERR_LC_REQ		0x81
#define	ERR_LC_CONF		0x82
#define	ERR_LC_PROF		0x83

/*-----------------------------------------------
 * define error point
 *---------------------------------------------*/
/* ca */
#define ERR_PT_CA		0x10
#define ERR_PT_CACRL	0x20
#define ERR_PT_CAFILE	0x30
#define ERR_PT_CAASN1	0x40
#define ERR_PT_CALCERTS	0x50
#define ERR_PT_CANEW	0x60
#define ERR_PT_CAPRINT	0x70
#define ERR_PT_CASIGN	0x80
#define ERR_PT_CATOOL	0x90
#define ERR_PT_CACONF	0xa0
#define ERR_PT_CAPOL	0xb0

/* prof */
#define ERR_PT_PROF		0x10
#define ERR_PT_PFTMPL	0x20
#define ERR_PT_PFASN1	0x30
#define ERR_PT_PFFILE	0x40
#define ERR_PT_PFTOOL	0x50

/* req */
#define ERR_PT_REQ		0x10

/* conf */
#define ERR_PT_CONF		0x10

/*-----------------------------------------------
 * define error state
 *---------------------------------------------*/
/* ca */
#define ERR_ST_CA_			0x8000
#define ERR_ST_CA_NOCSTAT	0x8001
#define ERR_ST_CA_NORSTAT	0x8002
#define ERR_ST_CA_NOEXT		0x8003
#define ERR_ST_CA_BADCONF	0x8004
#define ERR_ST_CA_BADCSV	0x8005
#define ERR_ST_CA_BADSN		0x8006
#define ERR_ST_CA_BADSUBJECT	0x8007
#define ERR_ST_CA_NOPROF	0x8008
#define ERR_ST_CA_CTREVOKED	0x8010
#define ERR_ST_CA_CTEXPIRED	0x8011
#define ERR_ST_CA_CANCELED	0x8020
#define ERR_ST_CA_POLMIS	0x8021

#ifdef  __cplusplus
}
#endif

#endif /* __OK_CAERR_H__ */

